%% Current Setting of this file allows the user to obtain values for Table I (a) 
% model II for X of type (ii)

% This implementation requires the following two packages to be downloaded
% http://research.microsoft.com/en-us/um/people/minka/software/fastfit/ 
% http://research.microsoft.com/en-us/um/people/minka/software/lightspeed/
% 

clear all
close all
clc
iter=1;     %number of iterations set to 200 in the simulation study

p=10;       %dimension of the predictors 
n=200;      %number of points
nslices=5; %number of slices
c=0.1;      %value of parameter c

model=2;%(I,II,III)%

data=2;%(i,ii,iii)%

if model==1
    dim=1;
    b=zeros(p,1);
    b([1,2,3])=[.6,-.4,.8];
    b=b/norm(b);
elseif model==2
    dim=1;
    b=eye(p,1);
elseif model==3
    dim=2;
    b=eye(p,2);  
end

tempo=zeros(iter,2);

for pp=1:iter

close all
clear X Y;

alfa=1;
gamma=2;


mu=zeros(1,p);


V=eye(p);

if data==1
  for i=1:p
    for j=1:p
      V(i,j)=0.5^(abs(i-j)); 
    end
  end
end

for i=1:n
if data==3    
%(iii)%
    for j=1:p
       if rand(1)<=0.8
       X(j,i)=randn(1);
       else
       X(j,i)=2*c*rand(1)-c;
       end
    end
elseif data==2
%(ii)
     X(:,i)=mvtrnd(V,1,1);
elseif data==1
%(i)
    X(:,i)=mvnrnd(zeros(1,p),V);
end
%-------------------------------------------    
    
Eps(i)=randn(1);



if model==1
Y(i)=1+0.6*X(1,i)-0.4*X(2,i)+0.8*X(3,i)+0.2*Eps(i);%(I)    
elseif model==2
Y(i)=(1+0.1*Eps(i))*X(1,i); %(II)
elseif model==3
Y(i)=X(1,i)/(0.5+(X(2,i)+1.5)^2)+0.2*Eps(i);%(III)

end

end


if p==2
figure, plot(X(1,:),X(2,:),'.');
end



%% SIR
t=cputime;
[passage,lambda,matfin]=sir2(X',Y,nslices);
tempo(pp,1)=cputime-t;
%figure, plot(X'*passage(:,1),Y,'.');
%title('SIR');
%% StudentSIR
t=cputime;
[B]=stSirI(X,Y,nslices,dim);
tempo(pp,2)=cputime-t;


%%
%SIR
proxSIR(pp)=trace(b*b'*orth(passage(:,1:dim))*orth(passage(:,1:dim))')/dim;
%student SIR
proxtSIR(pp)=trace(orth(B)*orth(B)'*b*b')/dim;




end

disp('SIR'),disp(mean(proxSIR)),disp(std(proxSIR));


disp('Student SIR'),disp(mean(proxtSIR)),disp(std(proxtSIR));

disp('Computational time:');
disp('SIR:'),disp(mean(tempo(:,1))),disp(std(tempo(:,1)));

disp('student SIR:'),disp(mean(tempo(:,2))),disp(std(tempo(:,2)));